%cutout - Function to cut selection out
function cutout(FileName,FileType,MinT,MaxT);

%Inputs:
%MinT -	%Start time to cut it out
%MaxT -	%End time to cut it out


ReadStep=200000;	%Data portion to read from HDD in a step

FileNameOut=[FileName,'_cut.'];	%Data output filename
fidDF=fopen(FileName);	%Opens trace file
switch FileType
case 1	%Axon Text File (.ATF) with 2 channels
    FileNameOut=[FileNameOut,'atf'];	%Data output filename
    fidOF=fopen(FileNameOut,'w');	%Opens trace file for writing
    fidHF=fopen([FileNameOut,'.tmp'],'w');	%Header file for writing
    for i=1:10	%Reading text file header
		DataNotes{i}=fgets(fidDF);
    end
   % Correct header according to acquisition mode
   switch sscanf(DataNotes{3},'%s')
	   case {'"AcquisitionMode=GapFree"'}
	   case {'"AcquisitionMode=EpisodicStimulation"'}
		   DataNotes{3}=sprintf('%s\n','"AcquisitionMode=Gap Free"');
		   for i=7:9
			   DataNotes{i}=DataNotes{i+1};
		   end
		   DataNotes{10}=fgets(fidDF);
   end
    
    mx=sscanf(DataNotes{5},'%6c %f %1c %f %2c');
    max2=mx(7); max3=mx(9);
    mx=sscanf(DataNotes{6},'%9c %f %1c %f %2c');
    min2=mx(10); min3=mx(12);
    
    
    XY=[0;0;0];
    Read=3*ReadStep;
    DelT=0;	%time shift initial value
    while Read>=3*ReadStep	%If the last time complete ReadStep length was read
	[XY,Read]=fscanf(fidDF,'%g %g %g',[3 ReadStep]);
	if Read~=0
	    [t,MinTN] = find((XY(1,:)<MinT));	%Points before cut
	    [t,MaxTN] = find((XY(1,:)>MaxT));	%Points after cut
	    if DelT==0
		if length(MinTN)~=0	%there is some piece of data before cut
		    MinTN_end_time=XY(1,MinTN(end))+(XY(1,MinTN(end))-XY(1,MinTN(end-1)));	%one time step after the last step
		end
		if length(MaxTN)~=0	%there is some piece of data after cut
		    MaxTN_first_time=XY(1,MaxTN(1));	%time of the first step
		    DelT=MaxTN_first_time-MinTN_end_time;	%time shift
		    XY(1,MaxTN)=XY(1,MaxTN)-DelT;	%Shifting time for the points after cut
		end
	    else
		XY(1,:)=XY(1,:)-DelT; 	%Shifting time for the points after cut
	    end
	    XY=[XY(:,MinTN),XY(:,MaxTN)];	%Cutting out the cut region
	    min2=min(min2,min(XY(2,:)));
	    max2=max(max2,max(XY(2,:)));
	    fprintf(fidOF,'%f\t %g\n',XY);
	    SndN(1)
	end
    end
    
    %Update extremums' values
    DataNotes{5}=[sprintf('%s','"YTop='), sprintf('%f',max2), sprintf('%s',','), sprintf('%f',max3), sprintf('%s\n','"')];
    DataNotes{6}=[sprintf('%s','"YBottom='), sprintf('%f',min2), sprintf('%s',','), sprintf('%f',min3), sprintf('%s\n','"')];
    
    for i=1:10	%ReWriting text file header with the updated extremums' values
	Lines=fprintf(fidHF,'%s',DataNotes{i});	%print 1 line with line terminators to the file
    end
    fclose(fidOF);	%Closes Data output file
    fclose(fidHF);	%Closes Header output file
    CommandString=['!copy "',FileNameOut,'.tmp" + "',FileNameOut,'" tmpfile.tmp'];
    eval(CommandString);
    CommandString=['!copy tmpfile.tmp "',FileNameOut,'"'];
    eval(CommandString);
    delete('tmpfile.tmp');
    delete([FileNameOut,'.tmp']);
case 2	%Axon Text File (.ATF) with 1 channel
    FileNameOut=[FileNameOut,'atf'];	%Data output filename
    fidOF=fopen(FileNameOut,'w');	%Opens trace file for writing
    fidHF=fopen([FileNameOut,'.tmp'],'w');	%Header file for writing
    
    for i=1:10	%Reading text file header
		DataNotes{i}=fgets(fidDF);
    end
   % Correct header according to acquisition mode
   % Correct header according to acquisition mode
   switch sscanf(DataNotes{3},'%s')
	   case {'"AcquisitionMode=GapFree"'}
	   case {'"AcquisitionMode=EpisodicStimulation"'}
		   DataNotes{3}=sprintf('%s\n','"AcquisitionMode=Gap Free"');
		   for i=7:9
			   DataNotes{i}=DataNotes{i+1};
		   end
		   DataNotes{10}=fgets(fidDF);
   end
    
    mx=sscanf(DataNotes{5},'%6c %f %2c');
    max2=mx(7);
    mx=sscanf(DataNotes{6},'%9c %f %2c');
    min2=mx(10);
    
    XY=[0;0];
    Read=2*ReadStep;
    DelT=0;	%time shift initial value
    MinTN_end_time=0;	%time of the Last number of the piece before cut
    MaxTN_first_time=0;	%time of the First number of the piece after cut
    while Read>=2*ReadStep	%If the last time complete ReadStep length was read
	[XY,Read]=fscanf(fidDF,'%g %g',[2 ReadStep]);
	if Read~=0
	    [t,MinTN] = find((XY(1,:)<MinT));	%Points before cut
	    [t,MaxTN] = find((XY(1,:)>MaxT));	%Points after cut
	    if DelT==0
		if length(MinTN)~=0	%there is some piece of data before cut
		    MinTN_end_time=XY(1,MinTN(end))+(XY(1,MinTN(end))-XY(1,MinTN(end-1)));	%one time step after the last step
		end
		if length(MaxTN)~=0	%there is some piece of data after cut
		    MaxTN_first_time=XY(1,MaxTN(1));	%time of the first step
		    DelT=MaxTN_first_time-MinTN_end_time;	%time shift
		    XY(1,MaxTN)=XY(1,MaxTN)-DelT;	%Shifting time for the points after cut
		end
	    else
		XY(1,:)=XY(1,:)-DelT; 	%Shifting time for the points after cut
	    end
	    XY=[XY(:,MinTN),XY(:,MaxTN)];	%Cutting out the cut region
	    min2=min(min2,min(XY(2,:)));
	    max2=max(max2,max(XY(2,:)));
	    fprintf(fidOF,'%f\t %g\n',XY);
	    SndN(1)
	end
    end
    
    %Update extremums' values
    DataNotes{5}=[sprintf('%s','"YTop='), sprintf('%f',max2), sprintf('%s\n','"')];
    DataNotes{6}=[sprintf('%s','"YBottom='), sprintf('%f',min2), sprintf('%s\n','"')];
    
    for i=1:10	%ReWriting text file header with the updated extremums' values
	Lines=fprintf(fidHF,'%s',DataNotes{i});	%print 1 line with line terminators to the file
    end
    fclose(fidOF);	%Closes Data output file
    fclose(fidHF);	%Closes Header output file
    CommandString=['!copy "',FileNameOut,'.tmp" + "',FileNameOut,'" tmpfile.tmp'];
    eval(CommandString);
    CommandString=['!copy tmpfile.tmp "',FileNameOut,'"'];
    eval(CommandString);
    delete('tmpfile.tmp');
    delete([FileNameOut,'.tmp']);
case 3	%Text File (.txt)
end

fclose(fidDF);	%Closes Data input file
SndN(2);
