%denoise - Function for substracting noise distribution from the histogram.
%Histogram is appoximated by syperimposition of noise histograms set. Number of noise histograms is equal to the number of bins.
%!!!Currently program is only for equally-spaced bins and linear criterion function estimation
function HstT=denoise(HstT,HstG,BinsT,MinZ,StepZ,MaxZ,RebTypeZ,InterpType,InterpLevZ,Dev,dir,Smoothing,SMethod);
global ecount_L HstT_L HstN_L par_valRange_L InterpType_L Smoothing_L SMethod_L h_L BinsT_L BinsT_Lp
BinsT_L=BinsT;
HstT_L=HstT;    %assigning local global variable
InterpType_L=InterpType;    %assigning local global variable
Smoothing_L=Smoothing;    %assigning local global variable
SMethod_L=SMethod;    %assigning local global variable
dbstop in tst_dev_max
%Inputs:
%HstT_L	- Initial trace vector
%HstG	- Histogram matrix (if noise will be calculated from the historgam
%BinsT_L 	- Trace bins vector
%MinZ 	- Minimal value for the range of noise determining 
%StepZ 	-  depending on RebTypeZ value,it could be: 
%MaxZ 	- Maximal value for the range of noise determining
%RebTypeZ 	- Source for the noise distribution histogram: <1*> 'Auto', <2> 'Point', <3> 'STD', <4> 'DataFile',
		% <5> 'HstFile', <6> 'TrcFile', <7> 'DataFragm', <8> 'HstFragm'
%InterpType_L 	- Type of estimation for the criterion function - <1> 'Linear', <2*> 'Linear Wtd', <3> 'Log', <4> 'Log Wtd'
%InterpLevZ	- Treshold for the criterion function.

%Output:
%HstT_L - Renewed histogram file of channel behavior cleaned of nouse
ecount_L=0;   %Function evaluations counter

if SMethod_L==0;Smoothing_L=0;end

HstT_L=HstT_L/sum(HstT_L);    %Normalizing initial histogram
if size(HstT_L,1)>size(HstT_L,2)
    HstT_L=HstT_L';
end

%==============	Target histogram evaluation
switch RebTypeZ %Source for the noise distribution histogram
case 1	%'Auto'
     MaxHstN_L=min(find(HstT_L==max(HstT_L)));   %Moda bin
     HstN_L=HstT_L(1:MaxHstN_L);	%Left half of noise histogram
     i=1:(MaxHstN_L-1);
     HstN_L(MaxHstN_L+i)=HstN_L(MaxHstN_L-i);	%Mirrored right half
     HstN_L=HstN_L/sum(HstN_L);    %!Normalizing noise histogram
     figure
     plot(HstN_L)	%!
case 2	%'Point'
    MaxHstN_L=fix(StepZ);   %Pointed bin
     HstN_L=HstT_L(1:MaxHstN_L);	%Left half of noise histogram
     i=1:(MaxHstN_L-1);
     HstN_L(MaxHstN_L+i)=HstN_L(MaxHstN_L-i);	%Mirrored right half
     HstN_L=HstN_L/sum(HstN_L);    %!Normalizing noise histogram
     figure
     plot(HstN_L)	%!
case 3	%'STD'
case 4	%'DataFile'
case 5	%'HstFile'
case 6	%'TrcFile'
    [HstN_L,BinsN0]=trcopen(StepZ);	%open trace file function
    MaxHstN_L=find(HstN_L==max(HstN_L));   %Moda bin
    BinsN0=BinsN0-(BinsN0(MaxHstN_L)+BinsN0(MaxHstN_L+1))/2;    %Setting moda bins as 0
    BinN=BinsT_L(2)-BinsT_L(1); %Single bin width from the initial trace
    BinsN=(BinsN0(1)-BinN):BinN:(BinsN0(end)+BinN); %New bins with width corresponding to initial trace
    HstN_L=distrhst(HstN_L,BinsN0,BinsN);	%Redistributing 1D histogram into new bins
    HstN_L=HstN_L/sum(HstN_L);    %!Normalizing noise histogram
    MaxHstN_L=find(HstN_L==max(HstN_L));   %!Moda bin
case 7	%'DataFragm'
case 8	%'HstFragm'
    
end

% switch InterpType_L
% case 1  %Linear
% case 2  %Linear Wtd
% case {3,4} %Log %Log Wtd
%   HstT_L(HstT_L==0)=min(HstT_L(HstT_L>0))/3;  %Replacing zero elements
% end

HstT_L(HstT_L==0)=min(HstT_L(HstT_L>0))/3;  %Replacing zero elements


for i=1:length(HstT_L)    %Determining noise and histograms columns ranges for addition
    par_valRange_L(1,i)=max(1,(MaxHstN_L+1-i)); %Minimal number of noise column
    par_valRange_L(2,i)=max(1,(i-MaxHstN_L+1)); %Minimal number of trace column
    par_valRange_L(3,i)=min(length(HstN_L),(MaxHstN_L+length(HstT_L)-i)); %Maximal number of noise column
    par_valRange_L(4,i)=min(length(HstT_L),(i+length(HstN_L)-MaxHstN_L)); %Maximal number of trace column
end

% ecount_L=0;    %Evaluations count
mx_stp=length(HstT_L)^2;	%Maximal evaluation steps number	
MaxIter=length(HstT_L)^1.5;	%Maximal iteration steps
%MaxIter=2000;
%-------- Parameters values vector initialization
%par_val(1:length(HstT_L))=1/length(HstT_L);  %Sets initial values for independent optimization parameters
par_val=log(HstT_L);	%Sets initial values for independent optimization parameters
h_L=figure;%
set(gca,'YScale','log');%Noise histogram

OptmAlgm=1;

%=============	Optimization algorithm

switch OptmAlgm %Select optimization algoritm
    
    
case 1  %-------------Random search optimization algorithm

%dev0=exp(dev);	%parameter deviation change rate
dev0=Dev;%2;	%parameter deviation change rate

dev=log(Dev)/100;	% (2)Deviation for optimization
%dev=0.7; else; dev=log(eval(dev)); end




TolX=InterpLevZ;	%Optimization parameter exit tolerance
%  TolX=0.0001;

TolFun=InterpLevZ;	%Optimization function exit tolerance
%      TolFun=0.0001;

% Smoothing_L=1;	%Smoothing_L coefficient 0 - no smoothing.
% SMethod_L=3;	%Smoothing_L method: <1> - neighbors ratio log dispersion; <2> - -logarithm maximization; <3> - combined 1 and 2

delta=randn(size(par_val))*dev;	%First parameters deviation
par_val=par_val.*exp(delta);	%Start parameters

delta=randn(size(par_val))*dev;	%First parameters deviation
par_val_t=par_val.*exp(delta);	%First test parameters

f=m_round(tst_dev(HstT_L,HstN_L,par_val,par_valRange_L,InterpType_L,Smoothing_L,SMethod_L),4);  %Start deviation

%block for initial data save

cont=1;	%flag to continue search
sdev(1)=2*f;	%Successful steps deviation matrix
sdev(2)=f;	%Successful steps deviation matrix
ntest=ceil(length(par_val)^.5)+1;	%Maximal number of test from one point with the same deviation
ctest=1;

%dir=1;	%Directed search
%dir=0;	%NonDirected search
dif=2;	%difference exponent between expanding and shrinking
dec1=1;	%Flag of first step decreasing

while cont>0
    d=tst_dev(HstT_L,HstN_L,par_val_t,par_valRange_L,InterpType_L,Smoothing_L,SMethod_L);  %Evaluate deviation for proposed parameters values
%     ecount_L=ecount_L+1;
    if d<sdev(end)	%successful step
        ctest=1;	%Resetting test number
        sdev(end+1)=d;	%Adding new step deviation
        par_val=par_val_t;	%Accepting new parameters
        dev=dev*(dev0^(1/dif));	%Increasing parameter deviation
        dec1=0;	%Flag of first step decreasing
%         cb s_save; cb r_save	%Saving temporal optimization results
%         save OptmResult.txt sdev -ascii
%         cwd = pwd;
%         cd('C:\windows\temp');
%         eval('pack')
%         cd(cwd)
        if dir ==1	%Directed search
            delta=delta*(dev0^(1/dif));
        else	%Undirected search
            delta=randn(size(par_val))*dev;
        end
        % set(findobj(1,'Tag','b_itrs'),'String',length(sdev))	%Number of inerations
        SndN(1);
        
        %*** test plotting block. Remove after debugging
        if floor(length(sdev)/50)==length(sdev)/50
           close(h_L)
            h_L=figure;%!
            BinsT_Lp=(BinsT_L(1:(end-1))+BinsT_L(2:end))/2;   %!Bins for plotting
            plot(BinsT_Lp,HstT_L,'b');%!
            hold on%!
            plot(BinsT_Lp,exp(par_val),'r');%!
            [t,HstT_Lr]=tst_dev(HstT_L,HstN_L,par_val,par_valRange_L,InterpType_L,Smoothing_L,SMethod_L);%!
            t%!Deviation
            plot(BinsT_Lp,HstT_Lr,'g');%!
            hold off%!
	    set(gca,'YScale','log');
            pause(1)%!
	    trcsave('TempSystemTrace',HstT_Lr,BinsT_L);
 	    trcsave('TempSystemTraceDen',par_val,BinsT_L);
        end
    else	%unsuccessful step
        if ctest<ntest	%Testing directions
            if dir ==1&ctest==1&dec1==1	%Directed search, 2n attempt, after search range shrink
                delta=-1*delta;
            else	%Undirected search
                delta=randn(size(par_val))*dev;
            end
            ctest=ctest+1;
        else	%Decreasing step size
            ctest=1;	%Resetting test number
            dev=dev/(dev0^dif);
            dec1=1;
            if dir ==1	%Directed search
                delta=-1*delta/(dev0^dif);
            else	%Undirected search
                delta=randn(size(par_val))*dev;
            end
        end
    end
    par_val_t=par_val.*exp(delta);
    m=mean(sdev(max(1,end-2*ntest):end));
    if m==0
        d_fun=0;
    else
        d_fun=abs(std(sdev(max(1,end-2*ntest):end))/m);%Average criterion function deviation in success steps
    end
    cont=min([(mx_stp-ecount_L),sdev(end),(d_fun-TolFun)]);	%Decides to continue search(>0) or not(<=0)
end
output.funcCount=ecount_L %! Function counts
output.iterations=length(sdev)  %!Number of approximation steps;
fval=sdev(end)  %!Final deviation value;


case 2	%-------------Genetic optimization algorithm
    options(11)=mx_stp/100;	%Population size
    options(12)=1;	%Crossover in mating occurs with probability
    options(13)=0; 	%offspring can mutate independently with probability
    options(14)=mx_stp/30;	%maximum generations
    bits=ones(size(par_val))*16;
    vlb=-ones(size(par_val))*(30);
    vub=ones(size(par_val))*30;
    [xopt,stats,options,bestf,fgen,lgen] = genetic('tst_dev_max(x)',par_val,options,vlb,vub,bits);
    output.funcCount=ecount_L;
    output.iterations=size(stats,1);
    par_val=val_get(par_set,restr);
    fval=tst_dev(par_val);
end

 
close(h_L)
h_L=figure;%!
BinsT_Lp=(BinsT_L(1:(end-1))+BinsT_L(2:end))/2;   %!Bins for plotting
plot(BinsT_Lp,HstT_L,'b');%!
hold on%!
plot(BinsT_Lp,exp(par_val),'r');%!
[t,HstT_Lr]=tst_dev(HstT_L,HstN_L,par_val,par_valRange_L,InterpType_L,Smoothing_L,SMethod_L);%!
t%!Deviation
plot(BinsT_Lp,HstT_Lr,'g');%!
hold off%!
set(gca,'YScale','log');
pause(1)%!
%close(h_L)

HstT_L=exp(par_val);    %Resulting denoised trace;




%============	Criterion function estimation subfunction
function [tdev,HstT_Lr]=tst_dev(HstT_L,HstN_L,par_val,par_valRange_L,InterpType_L,Smoothing_L,SMethod_L)
%Output:
%tdev   - integral deviation value

%Inputs:
%HstT_L	- Fitted trace histogram
%HstN_L	- Noise histogram
%par_val    - parameters' values vector
%par_valRange_L	-Range of including in consideration for each Noise-Bins pair
%InterpType_L 	- Type of estimation for the criterion function - <1> 'Linear', <2*> 'Linear Wtd', <3> 'Log', <4> 'Log Wtd'
%Smoothing_L	- Smooshing coefficient. <0> - no smoothing
%SMethod_L	- Smoothing_L method: <1> - neighbors ratio log dispersion; <2> - -logarithm maximization
global ecount_L
ecount_L=ecount_L+1;    %Function evaluations counter
HstT_Lr=zeros(1,length(par_val)); %Empty reconstructed histogram

for i=1:length(par_val)   %Cycle for filling up reconstructed histogram
    %for j=0:(par_valRange_L(4,i)-par_valRange_L(2,i))

    %Add next scaled noise bins set to the reconstructed histogram
    HstT_Lr(par_valRange_L(2,i):par_valRange_L(4,i))=HstT_Lr(par_valRange_L(2,i):par_valRange_L(4,i))+...
        HstN_L(par_valRange_L(1,i):par_valRange_L(3,i))*exp(par_val(i)); 
end

switch InterpType_L
case 1  %Linear
    tdev=(sum((HstT_L-HstT_Lr).^2)/length(HstT_L))^0.5;
    tdev=tdev*NonSmooth(par_val,Smoothing_L,SMethod_L);
case 2  %Linear Wtd
    Wht=mean([HstT_L;HstT_Lr]);    %weihgting vector
%     Wht(Wht==0)=1;  %uniting zero elements
    tdev=(sum(((HstT_L-HstT_Lr).^2)./Wht)/length(HstT_L))^0.5;
    tdev=tdev*NonSmooth(par_val,Smoothing_L,SMethod_L);
case 3  %Log
%     HstT_Lr(HstT_Lr==0)=min(HstT_Lr(HstT_Lr>0))/3;  %Replacing zero elements
    tdev=(sum(log(HstT_L./HstT_Lr).^2)/length(HstT_L))^0.5;
    tdev=tdev*NonSmooth(par_val,Smoothing_L,SMethod_L);
case 4  %Log Wtd
%     HstT_Lr(HstT_Lr==0)=min(HstT_Lr(HstT_Lr>0))/3;  %Replacing zero elements
    Wht=geomean([HstT_L;HstT_Lr]);    %weihgting vector
    tdev=(sum((log(HstT_L./HstT_Lr).^2).*(Wht.^0.5))/length(HstT_L))^0.5;
    tdev=tdev*NonSmooth(par_val,Smoothing_L,SMethod_L);
end



%============	Rebinning 1D histogram subfunction
function HstR=distrhst(Hst,BinsX,BinsXn)	%Redistributing 1D histogram
%Outputs:
%HstR -	Rebinned histogram file

%Inputs:
%Hst - 1D histogram data file
%BinsX -	Old bins vector for X axis
%BinsXn -	New X axes bins

HstR=zeros(1,length(BinsXn)-1);	%initializing new histogram

for i=1:(length(BinsX)-1)	%cicle through the old bins
    NMinXn=max(find(BinsXn<=BinsX(i))); %Maximal new bin boundary, lower than current old lower
    if length(NMinXn)==0;	%No new bin boundary, lower than current old low
	NMinXn=min(find(BinsXn<BinsX(i+1)));	%Minimal new bin boundary, lower than current old higher
    end
    
    NMaxXn=min(find(BinsXn>=BinsX(i+1))); %Minimal new bin boundary, higher than current old higher
    if length(NMaxXn)==0;	%No new bin boundary, higher than current old high
	NMaxXn=max(find(BinsXn>BinsX(i)));	%Minimal new bin boundary, lower than current old higher
    end
    
    if length(NMinXn)~=0&length(NMaxXn)~=0	%There some new bins intersecting with current old
	for k=NMinXn:(NMaxXn-1)
	    prp=min(BinsXn(k+1),BinsX(i+1))-max(BinsXn(k),BinsX(i));   %Proportion of old bin which overlap current new bin, relative to the length of the whole old bin
	    prp=prp/(BinsX(i+1)-BinsX(i));
	    HstR(k)=HstR(k)+Hst(i)*prp;	%Adding proportional part of old counts from old bin to the new one
	end
    end
end


%================	Smoothing_L deviation function
function NSm=NonSmooth(par_val,Smoothing_L,SMethod_L)

%Output:
%NSm - Non-smoothness coefficient

%Inputs:
%par_val	- Parameters vector to be smoothed
%Smoothing_L	- Smoothing_L value
%SMethod_L	- Smoothing_L estimation method

if Smoothing_L ~=0	%Some smoothing
    switch SMethod_L
    case 1	%neighbors ratio log dispersion
        NSm=log(par_val(1:(end-1))./par_val(2:end));	%Non-smoothness coefficient
        NSm=(1+std(NSm))^Smoothing_L;
    case 2	%-logarithm maximization
        NSm=(1+1/mean(abs(log(par_val)).^Smoothing_L)).^Smoothing_L;
    case 3	% <3> - combined 1 and 2
        NSm=log(par_val(1:(end-1))./par_val(2:end));	%Non-smoothness coefficient
        NSm=(1+std(NSm))^Smoothing_L;
        NSm2=(1+1/mean(abs(log(par_val)).^Smoothing_L)).^Smoothing_L;
        NSm=NSm*NSm2;
    case 4	%Piecewise rate smoothing
        par_valT=log(par_val);
        Smoothing_L=min(Smoothing_L,floor(length(par_val)/2-1));
        NSm=par_valT((1+Smoothing_L):(length(par_valT)-Smoothing_L));
        for i=1:Smoothing_L
            NSm=NSm+par_valT((1+Smoothing_L-i):(length(par_valT)-Smoothing_L-i))+par_valT((1+Smoothing_L+i):(length(par_valT)-Smoothing_L+i));
        end
        NSm=NSm/(2*Smoothing_L+1);	%This is geometrical mean between N=Smoothing_L different values
        NSm=abs(par_valT((1+Smoothing_L):(length(par_valT)-Smoothing_L))-NSm);
        NSm=(1+sum(NSm)/length(NSm)*Smoothing_L)^Smoothing_L;
        % 	NSm=log(par_val(1:(end-1))./par_val(2:end));	%Non-smoothness coefficient
        % 	TStd=0;
        % 	for i=1:length(NSm)
        % 	    TStd=TStd+std(NSm(max(1,(i-Smoothing_L)):min(length(NSm),(i+Smoothing_L))));
        % 	end
        % 	NSm=(1+TStd)^Smoothing_L;
    case 5  %Parameters std maximization
        NSm=log(par_val);
        NSm=(1+std(NSm))^(-1*Smoothing_L);
    case 6  %Acceleration minimization
        par_valT=log(par_val);
        NSm=par_valT(1:(end-2))+par_valT(3:end)-2*par_valT(2:(end-1));	%Non-smoothness coefficient
        NSm=(1+std(NSm))^Smoothing_L;
    end
else
    NSm=1;
end

%================ %Deviation estimation function for genetic algorithm
function f=tst_dev_max(x) %Deviation estimation function for genetic algorithm
global HstT_L HstN_L par_valRange_L InterpType_L Smoothing_L SMethod_L
[tdev,HstT_Lr]=tst_dev(HstT_L,HstN_L,x,par_valRange_L,InterpType_L,Smoothing_L,SMethod_L)
%Input - vector of independent parameters values
f=1/max(tdev,1e-200);