%filecnct - Function connecting several files together in one file
function filecnct(FileList,FileType);

%Inputs:
%FileList - list of files to connect
%FyleType - the same for all files


ReadStep=200000;	%Data portion to read from HDD in a step
FileName=FileList{1};
FileNameOut=[FileName,'_cnct.'];	%Data output filename
fidDF=fopen(FileName);	%Opens trace file

switch FileType
case 1	%Axon Text File (.ATF) with 2 channels
   FileNameOut=[FileNameOut,'atf'];	%Data output filename
   fidOF=fopen(FileNameOut,'w');	%Opens trace file for writing
   fidHF=fopen([FileNameOut,'.tmp'],'w');	%Header file for writing
   for i=1:10	%Reading text file header
	DataNotes{i}=fgets(fidDF);
   end
   % Correct header according to acquisition mode
   switch sscanf(DataNotes{3},'%s')
	   case {'"AcquisitionMode=GapFree"'}
	   case {'"AcquisitionMode=EpisodicStimulation"'}
		   DataNotes{3}=sprintf('%s\n','"AcquisitionMode=Gap Free"');
		   for i=7:9
			   DataNotes{i}=DataNotes{i+1};
		   end
		   DataNotes{10}=fgets(fidDF);
   end
   
   mx=sscanf(DataNotes{5},'%6c %f %1c %f %2c');
   max2=mx(7); max3=mx(9);
   mx=sscanf(DataNotes{6},'%9c %f %1c %f %2c');
   min2=mx(10); min3=mx(12);
case 2	%Axon Text File (.ATF) with 1 channel
   FileNameOut=[FileNameOut,'atf'];	%Data output filename
   fidOF=fopen(FileNameOut,'w');	%Opens trace file for writing
   fidHF=fopen([FileNameOut,'.tmp'],'w');	%Header file for writing
   
   for i=1:10	%Reading text file header
	DataNotes{i}=fgets(fidDF);
   end
   % Correct header according to acquisition mode
   switch sscanf(DataNotes{3},'%s')
	   case {'"AcquisitionMode=GapFree"'}
	   case {'"AcquisitionMode=EpisodicStimulation"'}
		   DataNotes{3}=sprintf('%s\n','"AcquisitionMode=Gap Free"');
		   for i=7:9
			   DataNotes{i}=DataNotes{i+1};
		   end
		   DataNotes{10}=fgets(fidDF);
   end
   
   mx=sscanf(DataNotes{5},'%6c %f %2c');
   max2=mx(7);
   mx=sscanf(DataNotes{6},'%9c %f %2c');
   min2=mx(10);
case 3	%Text File (.txt)
end
fclose(fidDF);	%Closes Data input file

pause(1)


LastTime=0; Delta=0;	%Initial values for the last step time and step value
%================= Block for total file data appending
for i=1:length(FileList)
   FileName=FileList{i};
   fidDF=fopen(FileName);	%Opens trace file
   switch FileType
   case 1	%Axon Text File (.ATF) with 2 channels
	for j=1:10	%Reading text file header
	   tnm{j}=fgets(fidDF);
	end
	% Correct header according to acquisition mode
   switch sscanf(tnm{3},'%s')
	   case {'"AcquisitionMode=GapFree"'}
	   case {'"AcquisitionMode=EpisodicStimulation"'}
		   tnm{10}=fgets(fidDF);
   end
	XY=[0;0;0];
	Read=3*ReadStep;
	while Read>=3*ReadStep	%If the last time complete ReadStep length was read
		[XY,Read]=fscanf(fidDF,'%g %g %g',[3 ReadStep]);
		if Read~=0
			min2=min(min2,min(XY(2,:)));
			max2=max(max2,max(XY(2,:)));
			min3=min(min3,min(XY(3,:)));
			max3=max(max3,max(XY(3,:)));
			if i~=1
				StartTime=XY(1,1);
				XY(1,:)=XY(1,:)-StartTime+LastTime+Delta;
			elseif Delta==0
				Delta=XY(1,end)-XY(1,(end-1));
			end
			LastTime=XY(1,end);
			fprintf(fidOF,'%f\t %g\t %g\n',XY);
			SndN(1)
		end
	end
	
   case 2	%Axon Text File (.ATF) with 1 channel
	for j=1:10	%Reading text file header
	   tnm{j}=fgets(fidDF);
	end
	% Correct header according to acquisition mode
   switch sscanf(tnm{3},'%s')
	   case {'"AcquisitionMode=GapFree"'}
	   case {'"AcquisitionMode=EpisodicStimulation"'}
		   tnm{10}=fgets(fidDF);
   end
	XY=[0;0];
	Read=2*ReadStep;
	while Read>=2*ReadStep	%If the last time complete ReadStep length was read
		[XY,Read]=fscanf(fidDF,'%g %g',[2 ReadStep]);
		if Read~=0
			min2=min(min2,min(XY(2,:)));
			max2=max(max2,max(XY(2,:)));
			if i~=1
				StartTime=XY(1,1);
				XY(1,:)=XY(1,:)-StartTime+LastTime+Delta;
			elseif Delta==0
				Delta=XY(1,end)-XY(1,(end-1));
			end
			LastTime=XY(1,end);
			fprintf(fidOF,'%f\t %g\n',XY);
			SndN(1)
		end
	end
   case 3	%Text File (.txt)
   end
   fclose(fidDF);	%Closes Data input file
end
SndN(2);

%=========================Block for file header writing

switch FileType
case 1	%Axon Text File (.ATF) with 2 channels
   %Update extremums' values
   DataNotes{5}=[sprintf('%s','"YTop='), sprintf('%f',max2), sprintf('%s',','), sprintf('%f',max3), sprintf('%s\n','"')];
   DataNotes{6}=[sprintf('%s','"YBottom='), sprintf('%f',min2), sprintf('%s',','), sprintf('%f',min3), sprintf('%s\n','"')];
   
   for i=1:10	%ReWriting text file header with the updated extremums' values
	Lines=fprintf(fidHF,'%s',DataNotes{i});	%print 1 line with line terminators to the file
   end
   fclose(fidOF);	%Closes Data output file
   fclose(fidHF);	%Closes Header output file
   CommandString=['!copy "',FileNameOut,'.tmp" + "',FileNameOut,'" tmpfile.tmp'];
   eval(CommandString);
   CommandString=['!copy tmpfile.tmp "',FileNameOut,'"'];
   eval(CommandString);
   delete('tmpfile.tmp');
   delete([FileNameOut,'.tmp']);
   
case 2	%Axon Text File (.ATF) with 1 channel
	%Update extremums' values
	DataNotes{5}=[sprintf('%s','"YTop='), sprintf('%f',max2), sprintf('%s\n','"')];
	DataNotes{6}=[sprintf('%s','"YBottom='), sprintf('%f',min2), sprintf('%s\n','"')];
	
	for i=1:10	%ReWriting text file header with the updated extremums' values
	   Lines=fprintf(fidHF,'%s',DataNotes{i});	%print 1 line with line terminators to the file
	end
	fclose(fidOF);	%Closes Data output file
	fclose(fidHF);	%Closes Header output file
	CommandString=['!copy "',FileNameOut,'.tmp" + "',FileNameOut,'" tmpfile.tmp'];
	eval(CommandString);
	CommandString=['!copy tmpfile.tmp "',FileNameOut,'"'];
	eval(CommandString);
	delete('tmpfile.tmp');
	delete([FileNameOut,'.tmp']);
case 3	%Text File (.txt)
end

pause(1)
SndN(3);

