%addpres - Function to add pressure to rough data file
function fusepres(FileName,FileType);	%Function to scale rough data file
%dbstop in interp1AGA
%Inputs:
%FileName	- Filename with extension
%FileType	- Axon text file with 2 channels <1*>, Axon text file with 1 channel <2>, text file <3>
ReadStep=200000;	%Data portion to read from HDD in a step

FileNamePres=[FileName,'_prs.'];	%Pressure file name
FileNameOut=[FileName,'_fuseprs.'];	%Data output filename
fidDF=fopen(FileName);	%Opens trace file



%***	Adding pressure to the rough data file
switch FileType
case 1	%Axon Text File (.ATF) with 2 channels
	FileNamePres=[FileNamePres,'atf'];	%Pressure file filename
	FileNameOut=[FileNameOut,'atf'];	%Data output filename
	fidPF=fopen(FileNamePres);	%Opens pressure file
	fidOF=fopen(FileNameOut,'w');	%Opens trace file for writing
	for i=1:10	%Reading text file header
		DataNotes{i}=fgets(fidDF);
		DataNotesP{i}=fgets(fidPF);
	end
   % Correct header according to acquisition mode
   switch sscanf(DataNotes{3},'%s')
	   case {'"AcquisitionMode=GapFree"'}
	   case {'"AcquisitionMode=EpisodicStimulation"'}
		   DataNotes{3}=sprintf('%s\n','"AcquisitionMode=Gap Free"');
		   for i=7:9
			   DataNotes{i}=DataNotes{i+1};
		   end
		   DataNotes{10}=fgets(fidDF);
   end
	
	mx=sscanf(DataNotes{5},'%6c %f %1c %f %2c');
	max2=mx(7);
	mx=sscanf(DataNotes{6},'%9c %f %1c %f %2c');
	min2=mx(10);
	
	mx=sscanf(DataNotesP{5},'%6c %f %1c %f %2c');
	max3=mx(9);
	mx=sscanf(DataNotesP{6},'%9c %f %1c %f %2c');
	min3=mx(12);
	
	DataNotes{2}=[sprintf('%s\t','7'), sprintf('%s\n','3')];
	DataNotes{5}=[sprintf('%s','"YTop='), sprintf('%f',max2), sprintf('%s',','), sprintf('%f',max3), sprintf('%s\n','"')];
	DataNotes{6}=[sprintf('%s','"YBottom='), sprintf('%f',min2), sprintf('%s',','), sprintf('%f',min3), sprintf('%s\n','"')];
	DataNotes{8}=sprintf('%s\n','"SignalsExported=Ipatch,Pressure"');
	DataNotes{9}=sprintf('%s\n','"Signals="	"Ipatch"	"Pressure"');
	DataNotes{10}=sprintf('%s\n','"Time (s)"	"Trace #1 (pA)"	"Trace #1 (mmHg)"');
	
	for i=1:10	%Writing text file header
		Lines=fprintf(fidOF,'%s',DataNotes{i});	%Prints  1 line with line terminators from the file
	end
	
	XY=[0;0];
	Read=6*ReadStep;
	while Read>=6*ReadStep	%If the last time complete ReadStep length was read
		[XY,Read]=fscanf(fidDF,'%g %g %g',[3 ReadStep]);
		[XP,ReadP]=fscanf(fidPF,'%g %g %g',[3 ReadStep]);
		if Read~=0 & ReadP~=0 	%There are some data read
			Read=Read+ReadP;
			LngP=min(size(XY,2),size(XP,2));
			TCP=[XY(1,1:LngP);XY(2,1:LngP);XP(3,1:LngP)];	%Time, current, pressure matrix
			fprintf(fidOF,'%f\t %g\t %g\n',TCP);
			SndN(1);
		end
	end
	
case 2	%Axon Text File (.ATF) with 1 channel
	FileNamePres=[FileNamePres,'atf'];	%Pressure file filename
	FileNameOut=[FileNameOut,'atf'];	%Data output filename
	fidPF=fopen(FileNamePres);	%Opens pressure file
	fidOF=fopen(FileNameOut,'w');	%Opens trace file for writing
	for i=1:10	%Reading text file header
		DataNotes{i}=fgets(fidDF);
		DataNotesP{i}=fgets(fidPF);
	end
   % Correct header according to acquisition mode
   % Correct header according to acquisition mode
   switch sscanf(DataNotes{3},'%s')
	   case {'"AcquisitionMode=GapFree"'}
	   case {'"AcquisitionMode=EpisodicStimulation"'}
		   DataNotes{3}=sprintf('%s\n','"AcquisitionMode=Gap Free"');
		   for i=7:9
			   DataNotes{i}=DataNotes{i+1};
		   end
		   DataNotes{10}=fgets(fidDF);
   end
	
	mx=sscanf(DataNotes{5},'%6c %f %2c');
	max2=mx(7);
	mx=sscanf(DataNotes{6},'%9c %f %2c');
	min2=mx(10);
	mx=sscanf(DataNotesP{5},'%6c %f %2c');
	max3=mx(7);
	mx=sscanf(DataNotesP{6},'%9c %f %2c');
	min3=mx(10);
	DataNotes{2}=[sprintf('%s\t','7'), sprintf('%s\n','3')];
	DataNotes{5}=[sprintf('%s','"YTop='), sprintf('%f',max2), sprintf('%s',','), sprintf('%f',max3), sprintf('%s\n','"')];
	DataNotes{6}=[sprintf('%s','"YBottom='), sprintf('%f',min2), sprintf('%s',','), sprintf('%f',min3), sprintf('%s\n','"')];
	DataNotes{8}=sprintf('%s\n','"SignalsExported=Ipatch,Pressure"');
	DataNotes{9}=sprintf('%s\n','"Signals="	"Ipatch"	"Pressure"');
	DataNotes{10}=sprintf('%s\n','"Time (s)"	"Trace #1 (pA)"	"Trace #1 (mmHg)"');
	
	for i=1:10	%Writing text file header
		Lines=fprintf(fidOF,'%s',DataNotes{i});	%Prints  1 line with line terminators from the file
	end
	
	XY=[0;0];
	Read=4*ReadStep;
	while Read>=4*ReadStep	%If the last time complete ReadStep length was read
		[XY,Read]=fscanf(fidDF,'%g %g',[2 ReadStep]);
		[XP,ReadP]=fscanf(fidPF,'%g %g',[2 ReadStep]);
		if Read~=0 & ReadP~=0 	%There are some data read
			Read=Read+ReadP;
			LngP=min(size(XY,2),size(XP,2));
			TCP=[XY(1,1:LngP);XY(2,1:LngP);XP(2,1:LngP)];	%Time, current, pressure matrix
			fprintf(fidOF,'%f\t %g\t %g\n',TCP);
			SndN(1);
		end
	end
case 3	%Text File (.txt)
end

fclose(fidPF);	%Closes Pressure file
fclose(fidDF);	%Closes Data input file
fclose(fidOF);	%Closes Data output file

SndN(2);
