%normhst - function, normalizing number of points into bin relative to the total amount of points in selected region
%Averaging regions with total zero number points (in the whole row or column of zeros) are filled by zeros
function HstN=normhst(Hst,NormRegion)

%Output:
%HstN -	Normalized histogram matrix.
%Input:
%Hst -	Histogram data matrix.
%NormRegion -	Normalizing region: the whole matrix <0>, Column (pressure) <1*>, Row (current) <2>.

HstN=Hst;
switch NormRegion
case 0 %Normalizing relative to the whole matrix
   NormNumb=sum(sum(HstN));	%Normalizing number
   if NormNumb>0; HstN=HstN/NormNumb; end
case 1 %Normalizing relative to the whole column (pressure)
   NormNumb=sum(HstN,1);
   for i=1:length(NormNumb)
      HstN(:,i)=HstN(:,i)/NormNumb(i);
   end
case 2 %Normalizing relative to the whole row (current)
   NormNumb=sum(HstN,2);
   for i=1:length(NormNumb)
      HstN(i,:)=HstN(i,:)/NormNumb(i);
   end
end
